/*******************************************************************************
 api_process.h

 Copyright (C) 2015-2020 CodeShop B.V.
 http://www.code-shop.com

 For licensing see the LICENSE file
******************************************************************************/

#ifndef API_PROCESS_H_AKW
#define API_PROCESS_H_AKW

#include "mod_streaming_export.h"
#include <inttypes.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef enum
{
  API_HTTP_GET = 0, // read
  API_HTTP_PUT,     // update
  API_HTTP_POST,    // create
  API_HTTP_DELETE   // delete
} api_http_method_t;

struct api_process_context_t;
typedef struct api_process_context_t api_process_context_t;

MP4_DLL_EXPORT extern
int api_process_context_init(api_process_context_t** actx,
                             mp4_process_context_t* pctx,
                             api_http_method_t method);

MP4_DLL_EXPORT
int api_process(api_process_context_t* actx,
                char const* body_start,
                char const* body_end);

MP4_DLL_EXPORT extern
void api_process_context_exit(api_process_context_t* actx);

#ifdef __cplusplus
} /* extern C definitions */
#endif

#endif // API_PROCESS_H_AKW

// End Of File
